<template>
	<a-spin :spinning="state.loading" size="large">
        <a-icon slot="indicator" type="loading" spin />
		<div class="row d-flex align-items-center">
			<div class="col-6">
				<h3>
					Изменить отдел
				</h3>
			</div>
			<div class="col-6 d-flex justify-content-end">
			    <a-button type="primary" icon="arrow-left" @click="$router.push({ name: 'UsersPage' })">Назад</a-button>
			</div>
			<div class="col-12" v-if="right">
				<form>
					<div class="form-group">
						<label>
							Название отдела <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите название отдела" v-model="department.name" />
					</div>
					<div class="form-group">
						<label>
							Описание отдела
						</label>
						<a-textarea placeholder="Введите описание отдела" :autosize="{ minRows: 6, maxRows: 12 }" v-model="department.description" />
					</div>
					<div class="form-group">
						<a-button type="primary" @click="prepareData">Отправить</a-button>
					</div>
				</form>
			</div>
			<div v-else>
				<a-alert message="У вас нет прав на эту операцию" type="error" />
			</div>
		</div>
	</a-spin>
</template>

<script type="text/javascript">
	export default {
		data () {
			return {
				department: '',
				state: {
					loading: false
				}
			}
		},
		created () {
			this.$http.get(this.$store.state.api.url+'getDepartment/'+this.$route.params.id)
			.then(this.loadDataSuccess, this.loadDataError);
			let scopes = JSON.parse(this.$store.state.user.scopes);
			for (var i = scopes.length - 1; i >= 0; i--) {
				if (scopes[i] === '*' || scopes[i] === 'departmentsRight') {
					this.right = true
				}
			}
		},
		methods: {
			prepareData () {
				if (this.department.name === '') {
					this.$message.error('Введите название отдела');
					return false;
				}
				console.log(this.department)
				this.updateDepartment(this.department);
			},
			loadDataSuccess (res) {
				this.department = res.body;
			},
			loadDataError (err) {
				console.log(err);
			},
			updateDepartment (data) {
				this.$http.post(this.$store.state.api.url+'updateDepartment', data)
				.then(this.updateDepartmentSuccess, this.updateDepartmentError);
			},
			updateDepartmentSuccess (res) {
				this.$message.success('Отдел изменен');
				this.$router.push({ name: 'UsersPage' });
			},
			updateDepartmentError (err) {
				console.log(err);
			}
		}
	} 
</script>